<!-- CrearEntrada.vue -->
<template>
    <div>
        <form @submit.prevent="storePost">
            <div class="mb-3">
                <div class="mb-3">
                    <label for="validationValidInput1">Título</label>
                    <input type="text" class="form-control is-valid" id="validationValidInput1"
                           placeholder="ingresa un título" v-model="title" required>
                </div>
                <div class="mb-3">
                    <label for="validationValidInput1">Autor</label>
                    <input type="text" class="form-control is-valid" id="validationValidInput1"
                           placeholder="ingresa un autor" v-model="author" required>
                </div>
                <div class="mb-3">
                    <label for="validationValidInput1">Fecha publicación</label>
                    <input type="date" class="form-control is-valid" id="validationValidInput1"
                           placeholder="ingresa una fecha de publicación" v-model="publication_date" required>
                </div>
                <div class="mb-3">
                    <label for="validationInvalidTextarea1">Contenido</label>
                    <textarea class="form-control" placeholder="ingresa el contenido" id="validationInvalidTextarea1" rows="4"
                              v-model="content" required></textarea>
                </div>
            </div>
            <div class="col-12 mt-4">
                <button type="submit" class="btn btn-primary w-100"><i class="bi bi-save"></i> Guardar</button>
            </div>
        </form>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    data() {
        return {
            title: '',
            author: '',
            publication_date: '',
            content: '',
            errorMessage: null,
        };
    },
    methods: {
        async storePost() {
            const response = await axios.post('api/v1/posts', {
                title: this.title,
                author: this.author,
                publication_date: this.publication_date,
                content: this.content,
            });
            if (response && response.status === 201 && response.data && response.data.data) {
                swal.fire({
                    icon: 'success',
                    title: 'Éxito',
                    text: 'El post se guardó exitosamente',
                });
                this.title = '';
                this.author = '';
                this.publication_date = '';
                this.content = '';
                this.$parent.actualizarListado();
            } else {
                swal.fire({
                    icon: 'error',
                    title: 'Error',
                    text: 'Error al procesar la solicitud.',
                });
            }
        },
        obtenerMensajesDeValidacion(errors) {
            const messages = Object.values(errors).flat();
            return messages.join(', ');
        },
    },
};
</script>
